﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Collections.Generic;
using System.ComponentModel;

namespace myCollection
{
    [DataObjectAttribute]
    public static class ContactList
    {
        private static List<Person> contactList;

        [DataObjectMethod(DataObjectMethodType.Select)]
        public static List<Person> GetContacts()
        {
            if (contactList == null)
                throw new ArgumentNullException("No Contacts defined!");
            return contactList;
        }

        [DataObjectMethod(DataObjectMethodType.Update)]
        public static void UpdateContact(Person p)
        {
            if (contactList == null)
                throw new ArgumentNullException("No Contacs defined!");
            foreach (Person person in contactList)
            {
                if (person.Index == p.Index)
                {
                    person.Age = p.Age;
                    person.FirstName = p.FirstName;
                    person.LastName = p.LastName;
                    person.CurrentLocation = p.CurrentLocation;
                }
            }
        }

        [DataObjectMethod(DataObjectMethodType.Insert)]
        public static void InsertContact(Person p)
        {
            if (contactList == null)
                contactList = new List<Person>();
            if (p.Index == new Guid())
                p.Index = Guid.NewGuid();
            contactList.Add(p);
        }

        [DataObjectMethod(DataObjectMethodType.Delete)]
        public static void DeleteContact(Person p)
        {
            for (int c = 0; c < contactList.Count; c++)
                if (contactList[c].Index == p.Index)
                    contactList.Remove(contactList[c]);
        }

        public static void DeleteContactByKey(Guid key)
        {
            for (int c = 0; c < contactList.Count; c++)
                if (contactList[c].Index == key)
                    contactList.Remove(contactList[c]);
        }

        static ContactList()
        {
            GenerateData();
        }

        static List<Person> GenerateData()
        {
            contactList = new List<Person>();

            contactList.Add(new Person("Ivan", "Shen", new Guid("3F2504E0-4F89-11D3-9A0C-0305E82C3316"), 22));
            contactList.Add(new Person("John", "Brown", new Guid("3F2504E0-4F89-11D3-9A0C-0305E82C3321"), 21));
            contactList.Add(new Person("Milen", "Dimitrov", new Guid("3F2504E0-4F89-11D3-9A0C-0305E82C3317"), 40));
            contactList.Add(new Person("Masako", "Oda", new Guid("3F2504E0-4F89-11D3-9A0C-0305E82C3310"), 35));
            contactList.Add(new Person("Evgeniy", "Prinochenko", new Guid("3F2504E0-4F89-11D3-9A0C-0305E82C3319"), 19));
            contactList.Add(new Person("Lia", "McGregory", new Guid("3F2504E0-4F89-11D3-9A0C-0305E82C3318"), 45));

            return contactList;
        }
    }
}
