﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Collections.Generic;
using System.ComponentModel;

namespace myCollection
{
    [DataObjectAttribute]
    public static class LocationList
    {
        private static List<Location> locationList;

        [DataObjectMethod(DataObjectMethodType.Select)]
        public static List<Location> GetLocations()
        {
            if (locationList == null)
                throw new ArgumentNullException("No Locations defined!");
            return locationList;
        }

        [DataObjectMethod(DataObjectMethodType.Update)]
        public static void UpdateLocation(Location l)
        {
            if (locationList == null)
                throw new ArgumentNullException("No Locations defined!");
            foreach (Location location in locationList)
            {
                if (location.Index == l.Index)
                {
                    location.City = l.City;
                    location.Country = l.Country;
                }
            }
        }

        [DataObjectMethod(DataObjectMethodType.Insert)]
        public static void InsertLocation(Location l)
        {
            if (locationList == null)
                locationList = new List<Location>();
            if (l.Index == new Guid())
                l.Index = Guid.NewGuid();
            locationList.Add(l);
        }

        [DataObjectMethod(DataObjectMethodType.Delete)]
        public static void DeleteLocation(Location l)
        {
            for (int c = 0; c < locationList.Count; c++)
                if (locationList[c].Index == l.Index)
                    locationList.Remove(locationList[c]);
        }

        static LocationList()
        {
            GenerateData();
        }

        static List<Location> GenerateData()
        {
            locationList = new List<Location>();

            locationList.Add(new Location(new Guid("3F2504E0-4F89-11D3-9A0C-000000000000"), "NotSet", "NotSet"));
            locationList.Add(new Location(new Guid("3F2504E0-4F89-11D3-9A0C-0305E82C3310"), "Osaka", "Japan"));
            locationList.Add(new Location(new Guid("3F2504E0-4F89-11D3-9A0C-0305E82C3311"), "New York", "USA"));
            locationList.Add(new Location(new Guid("3F2504E0-4F89-11D3-9A0C-0305E82C3312"), "Sydney", "Australia"));
            locationList.Add(new Location(new Guid("3F2504E0-4F89-11D3-9A0C-0305E82C3313"), "Tokyo", "Japan"));
            locationList.Add(new Location(new Guid("3F2504E0-4F89-11D3-9A0C-0305E82C3314"), "Manchester", "England"));
            locationList.Add(new Location(new Guid("3F2504E0-4F89-11D3-9A0C-0305E82C3315"), "Paris", "France"));
            locationList.Add(new Location(new Guid("3F2504E0-4F89-11D3-9A0C-0305E82C3316"), "Beijing", "China"));
            locationList.Add(new Location(new Guid("3F2504E0-4F89-11D3-9A0C-0305E82C3317"), "Sofia", "Bulgaria"));
            locationList.Add(new Location(new Guid("3F2504E0-4F89-11D3-9A0C-0305E82C3318"), "Washington", "USA"));
            locationList.Add(new Location(new Guid("3F2504E0-4F89-11D3-9A0C-0305E82C3319"), "Lyon", "France"));
            locationList.Add(new Location(new Guid("3F2504E0-4F89-11D3-9A0C-0305E82C3320"), "London", "England"));
            locationList.Add(new Location(new Guid("3F2504E0-4F89-11D3-9A0C-0305E82C3321"), "Melbourne", "Australia"));

            return locationList;
        }
    }
}
