﻿using System;
using System.Collections.Generic;
using System.Web;
using Telerik.Web.UI;
using System.Web.UI;
using System.Web.UI.WebControls;

public class myCommandItemTemplate : ITemplate
{
    Button btnEditSelected;
    Button btnUpdateEdited;
    Button btnCancel;
    Button btnInitInsert;
    Button btnPerformInsert;
    Button btnDeleteSelected;
    Button btnRebindGrid;

    public myCommandItemTemplate()
    { }

    public void InstantiateIn(Control container)
    {
        container.DataBinding += new EventHandler(container_DataBinding);

        btnEditSelected = new Button();
        btnEditSelected.ID = "btnEditSelected";
        btnEditSelected.CommandName = "EditSelected";
        btnEditSelected.CausesValidation = false;
        btnEditSelected.Text = "Edit Selected Products";

        btnUpdateEdited = new Button();
        btnUpdateEdited.ID = "btnUpdateEdited";
        btnUpdateEdited.CommandName = "UpdateEdited";
        btnUpdateEdited.Text = "Update Products";

        btnCancel = new Button();
        btnCancel.ID = "btnCancel";
        btnCancel.CommandName = "CancelAll";
        btnCancel.CausesValidation = false;
        btnCancel.Text = "Cancel editing";

        btnInitInsert = new Button();
        btnInitInsert.ID = "btnInitInsert";
        btnInitInsert.CommandName = "InitInsert";
        btnInitInsert.CausesValidation = false;
        btnInitInsert.Text = "Add new Product";

        btnPerformInsert = new Button();
        btnPerformInsert.ID = "btnPerformInsert";
        btnPerformInsert.CommandName = "PerformInsert";
        btnPerformInsert.Text = "Add this Product";

        btnDeleteSelected = new Button();
        btnDeleteSelected.ID = "btnDeleteSelected";
        btnDeleteSelected.CommandName = "DeleteSelected";
        btnDeleteSelected.CausesValidation = false;
        btnDeleteSelected.Text = "Delete Selected Products";

        btnRebindGrid = new Button();
        btnRebindGrid.ID = "btnRebindGrid";
        btnRebindGrid.CommandName = "Refresh Products";
        btnRebindGrid.Text = "Refresh Products";

        container.Controls.Add(btnEditSelected);
        container.Controls.Add(btnUpdateEdited);
        container.Controls.Add(btnCancel);
        container.Controls.Add(btnInitInsert);
        container.Controls.Add(btnPerformInsert);
        container.Controls.Add(btnDeleteSelected);
        container.Controls.Add(btnRebindGrid);
    }

    void container_DataBinding(object sender, EventArgs e)
    {
        GridCommandItem item = (GridCommandItem)((Control)sender).NamingContainer;
        RadGrid radGrid1 = item.OwnerTableView.OwnerGrid;
        btnEditSelected.Visible = radGrid1.EditIndexes.Count == 0;
        btnUpdateEdited.Visible = radGrid1.EditIndexes.Count > 0;
        btnCancel.Visible = radGrid1.EditIndexes.Count > 0 || radGrid1.MasterTableView.IsItemInserted;
        btnInitInsert.Visible = !radGrid1.MasterTableView.IsItemInserted;
        btnPerformInsert.Visible = radGrid1.MasterTableView.IsItemInserted;
    }
}
