using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Collections.Generic;
using Telerik.Web.UI;
using myCollection;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Init(object sender, EventArgs e)
    {
        RadGrid radGrid1 = new RadGrid();
        radGrid1.ID = "radGrid1";
        radGrid1.NeedDataSource += new GridNeedDataSourceEventHandler(RadGrid1_NeedDataSource);
        radGrid1.AllowMultiRowSelection = true;
        radGrid1.AutoGenerateEditColumn = true;
        radGrid1.AutoGenerateDeleteColumn = true;
        radGrid1.GridLines = GridLines.None;
        radGrid1.Skin = "Vista";
        radGrid1.AllowMultiRowEdit = true;
        radGrid1.DeleteCommand +=new GridCommandEventHandler(RadGrid1_DeleteCommand);
        radGrid1.InsertCommand += new GridCommandEventHandler(RadGrid1_InsertCommand);
        radGrid1.UpdateCommand += new GridCommandEventHandler(RadGrid1_UpdateCommand);
        radGrid1.ItemCreated +=new GridItemEventHandler(RadGrid1_ItemCreated);
        radGrid1.MasterTableView.CommandItemDisplay = GridCommandItemDisplay.Top;
        radGrid1.MasterTableView.AutoGenerateColumns = false;
        radGrid1.MasterTableView.OverrideDataSourceControlSorting = true;
        radGrid1.MasterTableView.ShowFooter = true;
        radGrid1.MasterTableView.EditMode = GridEditMode.InPlace;
        radGrid1.MasterTableView.UseAllDataFields = true;
        radGrid1.MasterTableView.DataKeyNames = new string[] { "Index" };
        radGrid1.ClientSettings.Selecting.AllowRowSelect = true;

        myCommandItemTemplate template = new myCommandItemTemplate();
        radGrid1.MasterTableView.CommandItemTemplate = template;

        GridClientSelectColumn selectColumn = new GridClientSelectColumn();
        radGrid1.Columns.Add(selectColumn);

        GridBoundColumn boundColumn = new GridBoundColumn();
        boundColumn.DataField = "Index";
        boundColumn.DataType = typeof(Guid);
        boundColumn.ReadOnly = true;
        boundColumn.Visible = false;
        boundColumn.UniqueName = "Index";
        radGrid1.Columns.Add(boundColumn);

        boundColumn = new GridBoundColumn();
        boundColumn.DataField = "FirstName";
        boundColumn.HeaderText = "FirstName";
        boundColumn.SortExpression = "FirstName";
        boundColumn.UniqueName = "FirstName";
        radGrid1.Columns.Add(boundColumn);

        boundColumn = new GridBoundColumn();
        boundColumn.DataField = "LastName";
        boundColumn.HeaderText = "LastName";
        boundColumn.SortExpression = "LastName";
        boundColumn.UniqueName = "LastName";
        radGrid1.Columns.Add(boundColumn);

        GridDropDownColumn dropDownColumn = new GridDropDownColumn();
        dropDownColumn.DataField = "CurrentLocation";
        dropDownColumn.ListTextField = "City";
        dropDownColumn.ListValueField = "Index";
        dropDownColumn.DropDownControlType = GridDropDownColumnControlType.DropDownList;
        dropDownColumn.HeaderText = "City";
        dropDownColumn.UniqueName = "CurrentLocation";
        dropDownColumn.ForceExtractValue = GridForceExtractValues.Always;
        radGrid1.Columns.Add(dropDownColumn);

        boundColumn = new GridBoundColumn();
        boundColumn.DataField = "Age";
        boundColumn.HeaderText = "Age";
        boundColumn.SortExpression = "Age";
        boundColumn.UniqueName = "Age";
        boundColumn.DataType = typeof(Int32);
        radGrid1.Columns.Add(boundColumn);

        PlaceHolder1.Controls.Add(radGrid1);
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        RadGrid radGrid1 = PlaceHolder1.FindControl("radGrid1") as RadGrid;

        RadAjaxManager1.AjaxSettings.AddAjaxSetting(radGrid1, radGrid1);
    }

    protected void RadGrid1_NeedDataSource(object source, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
    {
        (source as RadGrid).DataSource = ContactList.GetContacts();
    }

    protected void RadGrid1_InsertCommand(object source, GridCommandEventArgs e)
    {
        Hashtable hashtable = new Hashtable();
        GridDataItem item = e.Item as GridDataItem;
        item.ExtractValues(hashtable);
        ContactList.InsertContact(new Person(hashtable["FirstName"].ToString(), hashtable["LastName"].ToString(), new Guid(hashtable["CurrentLocation"].ToString()), int.Parse(hashtable["Age"].ToString())));
    }

    protected void RadGrid1_UpdateCommand(object source, GridCommandEventArgs e)
    {
        Hashtable hashtable = new Hashtable();
        GridDataItem item = e.Item as GridDataItem;
        item.ExtractValues(hashtable);
        ContactList.UpdateContact(new Person(new Guid(item.GetDataKeyValue("Index").ToString()), hashtable["FirstName"].ToString(), hashtable["LastName"].ToString(), new Guid(hashtable["CurrentLocation"].ToString()), int.Parse(hashtable["Age"].ToString())));
    }

    protected void RadGrid1_DeleteCommand(object source, GridCommandEventArgs e)
    {
        Hashtable hashtable = new Hashtable();
        GridDataItem item = e.Item as GridDataItem;
        item.ExtractValues(hashtable);
        ContactList.DeleteContactByKey(new Guid(item.GetDataKeyValue("Index").ToString()));
    }

    bool assign = false;

    protected void RadGrid1_ItemCreated(object sender, GridItemEventArgs e)
    {
        if (e.Item is GridDataItem && !assign)
        {
            GridDataItem item = e.Item as GridDataItem;
            GridDropDownColumn column = (sender as RadGrid).MasterTableView.Columns.FindByUniqueName("CurrentLocation") as GridDropDownColumn;
            GridDropDownColumnEditor editor = column.ColumnEditor as GridDropDownColumnEditor;
            editor.DataSource = LocationList.GetLocations();
            assign = true;
        }
    }
}